//---------------------------------------------------------------------------
#ifndef plotmainH
#define plotmainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include "graph.h"
#include "rtklib.h"

#define MAXNFILE    32					// max number of solution files

//---------------------------------------------------------------------------
class TPlot : public TForm
{
__published:
	TPanel *Panel2;
	TLabel *Message2;
	TPanel *Panel1;
	TPanel *Panel11;
	TButton *BtnExit;
	TPanel *Panel22;
	TComboBox *PlotTypeSol;
	TButton *BtnOption;
	TScrollBar *TimeScroll;
	TComboBox *QFlag;
	TButton *BtnRead;
	TOpenDialog *OpenDialog;
	TSpeedButton *BtnSol1;
	TSpeedButton *BtnSol2;
	TSpeedButton *BtnSol12;
	TSpeedButton *BtnOrigin;
	TSpeedButton *BtnFitV;
	TPaintBox *Disp;
	TLabel *Message1;
	TPanel *Panel21;
	TLabel *QL1;
	TLabel *QL2;
	TLabel *QL3;
	TLabel *QL4;
	TLabel *QL5;
	TLabel *QL6;
	TSpeedButton *BtnFitH;
	TComboBox *ObsType;
	TComboBox *PlotTypeObs;
	TSpeedButton *BtnTrack;
	TComboBox *DopType;
	TSpeedButton *BtnReload;
	TSpeedButton *BtnPoint;
	TSpeedButton *BtnOn1;
	TSpeedButton *BtnOn2;
	TSpeedButton *BtnOn3;
	void __fastcall BtnExitClick(TObject *Sender);
	void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall PlotTypeSolChange(TObject *Sender);
	void __fastcall DispMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall DispMouseLeave(TObject *Sender);
	void __fastcall DispMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall DispMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall BtnOptionClick(TObject *Sender);
	void __fastcall TimeScrollChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall QFlagChange(TObject *Sender);
	void __fastcall BtnSol1Click(TObject *Sender);
	void __fastcall BtnSol2Click(TObject *Sender);
	void __fastcall BtnFitVClick(TObject *Sender);
	void __fastcall BtnOriginClick(TObject *Sender);
	void __fastcall BtnReadClick(TObject *Sender);
	void __fastcall BtnSol12Click(TObject *Sender);
	void __fastcall DispPaint(TObject *Sender);
	void __fastcall BtnFitHClick(TObject *Sender);
	void __fastcall ObsTypeChange(TObject *Sender);
	void __fastcall PlotTypeObsChange(TObject *Sender);
	void __fastcall BtnTrackClick(TObject *Sender);
	void __fastcall DopTypeChange(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall BtnReloadClick(TObject *Sender);
	void __fastcall BtnPointClick(TObject *Sender);
	void __fastcall BtnOn1Click(TObject *Sender);
	void __fastcall BtnOn2Click(TObject *Sender);
	void __fastcall BtnOn3Click(TObject *Sender);
private:
	Graphics::TBitmap *Buff;
	char *RFiles[MAXNFILE],RFiles_[MAXNFILE][1024];
	int Drag,Xn,Yn,NRPos[2],NObs,*IndexObs,RawObs;
	int Week,DispUpdate,NFile,PlotType,PosType;
	AnsiString Files[2];
	solp_t Sol[2];
	double X0,Y0,Xc,Yc,Xs,Ys,OPos[3],RPos[2][10][3],*Az,*El;
	TGraph *GraphT,*GraphG[3],*GraphR,*GraphS;
	int __fastcall CheckRaw(const char *file);
	void __fastcall Refresh(void);
	void __fastcall Redraw(void);
	void __fastcall DrawGraphT(int level);
	void __fastcall DrawGraphTD(int level);
	void __fastcall DrawGraphTC(double *x, double *y, double *z,
		int *q, double *xs, double *ys, double *xys, int m, int level, int style);
	void __fastcall DrawStatTC(double *x, double *y, double *z, int m, int p);
	void __fastcall DrawGraphG(int level);
	void __fastcall DrawGraphGD(int level);
	void __fastcall DrawGraphGC(gtime_t *t, double *x, double *y,
		double *z, int *q, double *xs, double *ys, double *zs, int m, int level,
		int style);
	void __fastcall DrawStatGC(double *x, double *y, double *z, int m,
		AnsiString unit, int p);
	void __fastcall DrawRaw(int level);
	void __fastcall DrawSats(int level);
	void __fastcall DrawDop(int level);
	void __fastcall DrawStatDop(double *dop, int *ns, int n);
	void __fastcall UpdateOpt(void);
	void __fastcall UpdateColor(void);
	void __fastcall UpdateSize(void);
	void __fastcall UpdateSelect(void);
	void __fastcall UpdateTime(void);
	void __fastcall UpdateInfo(void);
	void __fastcall UpdatePoint(int x, int y);
	void __fastcall UpdateOrigin(void);
	void __fastcall UpdateLimTime(int all);
	void __fastcall UpdateLimFit(int all);
	void __fastcall UpdateLimOri(int all);
	void __fastcall UpdateEnable(void);
	void __fastcall GetTimeSpan(gtime_t *ts, gtime_t *te, double *tint);
	int __fastcall SearchPos(int x, int y);
	int __fastcall ObsColor(const obsd_t *obs, double el);
	int __fastcall SolToXyz(const solpd_t *data, int n, gtime_t *t,
		double *x, double *y, double *z, int *q, double *xs, double *ys,
		double *zs, double *xys, int qflag, int type);
	int __fastcall SolDiff(gtime_t *time, double *x, double *y,
		double *z, int *q, int n);
	double __fastcall SolToVel(gtime_t time1, gtime_t time0,
		const double *pos1, const double *pos0, double &dir);
	void __fastcall DrawArrow(const gtime_t *t, const double *x,
		const double *y, int n);
	void __fastcall CalcStats(const double *x, int n, double ref, double &ave,
		double &std, double &rms);
	void __fastcall SatAzel(const obs_t *obs, const nav_t *nav,
		const sbs_t *sbs, double *az, double *el);
		double __fastcall TimePos(gtime_t time);
	AnsiString __fastcall TimeStr(gtime_t time, int n, int tsys);
	int __fastcall ScreenTime(gtime_t time);
	void __fastcall ShowMsg(AnsiString msg);
	void __fastcall ShowLegend(AnsiString *msgs);
	void __fastcall LoadOpt(void);
	void __fastcall SaveOpt(void);
	void __fastcall DropFiles(TWMDropFiles msg); // for files drop
	BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_DROPFILES,TWMDropFiles,DropFiles);
	END_MESSAGE_MAP(TForm);
public:
	obs_t Obs;
	nav_t Nav;
	sbs_t Sbs;
	
	// options 
	AnsiString TimeY1,TimeH1,TimeY2,TimeH2;
	int TimeStart,TimeEnd,TimeIntF,ObsFormat,TimeLabel,AutoScale,ShowStats;
	int ShowArrow,ShowSlip,ShowErr,ShowEph,EnaSbas,PlotStyle,MarkSize,Origin;
	double TimeInt,ElMask,YRange,OOPos[3];
	TColor MColor[7],CColor[4];
	
	__fastcall TPlot(TComponent* Owner);
	int __fastcall ReadSol(char *files[], int nfile);
	int __fastcall ReadRaw(char *files[], int nfile);
};
//---------------------------------------------------------------------------
extern PACKAGE TPlot *Plot;
//---------------------------------------------------------------------------
#endif
