//---------------------------------------------------------------------------
// postmain.cpp : rtkpost main (rtklib post-processing analysis)
//
//			Copyright (C) 2007 by T.TAKASU, All rights reserved.
//
// version : $Revision: 1.1 $ $Date: 2008/07/17 22:14:45 $
// history : 2008/07/14  1.0 new
//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <vcl.h>
#pragma hdrstop

#include "postmain.h"
#include "postopt.h"
#include "kmzconv.h"
#include "refdlg.h"
#include "viewer.h"
#include "confdlg.h"
#include "rtklib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

#define PRGNAME		"RTKPOST ver.2.1.0"
#define MAXHIST		20
#define GOOGLE_EARTH "C:\\Program Files\\Google\\Google Earth\\googleearth.exe"

static const char version[]="$Revision: 1.1 $ $Date: 2008/07/17 22:14:45 $";

//---------------------------------------------------------------------------
extern "C" {
int showmsg(char *format, ...)
{
	va_list arg;
	char buff[1024];
	va_start(arg,format); vsprintf(buff,format,arg); va_end(arg);
	MainForm->ShowMsg(buff);
	if (strncmp(buff,"processing",10)) Application->ProcessMessages();
	return !MainForm->BtnExec->Enabled;
}
static gtime_t tstart={0},tend={0};
void settspan(gtime_t ts, gtime_t te) {tstart=ts; tend=te;}
void settime(gtime_t time)
{
	static int i=0;
	double tt=timediff(tend,tstart);
	if (tt>0.0) {
		MainForm->Progress->Position=(int)(timediff(time,tstart)/tt*100.0+0.5);
	}
	if (i++%23==0) Application->ProcessMessages();
}
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
	DynamicModel=IonoEst=TropEst=RovAntPcv=RefAntPcv=AmbRes=0;
	RovPosType=RefPosType=0;
	OutCntResetBias=5; LockCntFixAmb=5;
	MaxAgeDiff=30.0; RejectThres=30.0;
	MeasErr1=100.0; MeasErr2=0.004; MeasErr3=0.003; MeasErr4=0.01;
	SatClkStab=1E-11; ValidThresAR=3.0;
	RovAnt=RefAnt=PrecEphFile=StaPosFile=AntPcvFile=GoogleEarthFile="";
	RovAntE=RovAntN=RovAntU=RefAntE=RefAntN=RefAntU=0.0;
	for (int i=0;i<3;i++) RovPos[i]=0.0;
	for (int i=0;i<3;i++) RefPos[i]=0.0;
	DoubleBuffered=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
	TIniFile *ini=new TIniFile("rtkpost.ini");
	TimeStart->Checked =ini->ReadInteger("set","timestart",0);
	TimeEnd->Checked   =ini->ReadInteger("set","timeend",0);
	TimeSys1->Caption  =ini->ReadString ("set","timesys1","(YMDhms)");
	TimeY1->Text	   =ini->ReadString ("set","timey1","2000/01/01");
	TimeY1->Text	   =ini->ReadString ("set","timey1","2000/01/01");
	TimeH1->Text	   =ini->ReadString ("set","timeh1","00:00:00");
	TimeSys2->Caption  =ini->ReadString ("set","timesys2","(YMDhms)");
	TimeY2->Text	   =ini->ReadString ("set","timey2","2000/01/01");
	TimeH2->Text	   =ini->ReadString ("set","timeh2","00:00:00");
	TimeIntF ->Checked =ini->ReadInteger("set","timeintf",0);
	TimeInt->Text	   =ini->ReadString ("set","timeint","0");
	TimeUnitF->Checked =ini->ReadInteger("set","timeunitf",0);
	TimeUnit->Text	   =ini->ReadString ("set","timeunit","24");
	InputFile1->Text   =ini->ReadString ("set","inputfile1","");
	InputFile2->Text   =ini->ReadString ("set","inputfile2","");
	InputFile3->Text   =ini->ReadString ("set","inputfile3","");
	OutputFile->Text   =ini->ReadString ("set","outputfile","");
	InputFormat1->ItemIndex=ini->ReadInteger("set","inputformat1",0);
	InputFormat3->ItemIndex=ini->ReadInteger("set","inputformat3",0);
	
	InputFile1->Items  =ReadList(ini,"hist","inputfile1");
	InputFile2->Items  =ReadList(ini,"hist","inputfile2");
	InputFile3->Items  =ReadList(ini,"hist","inputfile3");
	OutputFile->Items  =ReadList(ini,"hist","outputfile");
	
	PosMode			   =ini->ReadInteger("opt","posmode",2);
	Freq			   =ini->ReadInteger("opt","freq",1);
	Solution		   =ini->ReadInteger("opt","solution",0);
	ElMask			   =ini->ReadFloat	("opt","elmask",15.0);
	SnrMask			   =ini->ReadFloat	("opt","snrmask",0.0);
	SolFormat		   =ini->ReadInteger("opt","solformat",0);
	TimeFormat		   =ini->ReadInteger("opt","timeformat",1);
	LatLonFormat	   =ini->ReadInteger("opt","latlonformat",0);
	FieldSep		   =ini->ReadString ("opt","fieldsep","");
	OutputHead		   =ini->ReadInteger("opt","outputhead",1);
	OutputOpt		   =ini->ReadInteger("opt","outputopt",1);
	OutputDatum		   =ini->ReadInteger("opt","outputdatum",0);
	OutputHeight	   =ini->ReadInteger("opt","outputheight",0);
	OutputGeoid		   =ini->ReadInteger("opt","outputgeoid",0);
	DebugTrace		   =ini->ReadInteger("opt","debugtrace",0);
	OutputFile->Text   =ini->ReadString ("opt","outputfile","");
	DynamicModel	   =ini->ReadInteger("opt","dynamicmodel",0);
	IonoEst			   =ini->ReadInteger("opt","ionoest",0);
	TropEst			   =ini->ReadInteger("opt","tropest",0);
	ValidThresAR	   =ini->ReadFloat	("opt","validthresar",3.0);
	AmbRes			   =ini->ReadInteger("opt","ambres",1);
	OutCntResetBias    =ini->ReadInteger("opt","outcntresetbias",5);
	LockCntFixAmb	   =ini->ReadInteger("opt","lockcntfixamb",0);
	ElMaskAR		   =ini->ReadFloat	("opt","elmaskar",0.0);
	MaxAgeDiff		   =ini->ReadFloat	("opt","maxagediff",30.0);
	RejectThres		   =ini->ReadFloat	("opt","rejectthres",30.0);
	SlipThres		   =ini->ReadFloat	("opt","slipthres",0.05);
	CodeSmooth		   =ini->ReadInteger("opt","codesmooth",0);
	NumIter			   =ini->ReadInteger("opt","numiter",1);
	MeasErr1		   =ini->ReadFloat	("opt","measerr1",100.0);
	MeasErr2		   =ini->ReadFloat	("opt","measerr2",0.003);
	MeasErr3		   =ini->ReadFloat	("opt","measerr3",0.003);
	MeasErr4		   =ini->ReadFloat	("opt","measerr4",0.000);
	SatClkStab		   =ini->ReadFloat	("opt","satclkstab",5E-12);
	PrNoise1		   =ini->ReadFloat	("opt","prnoise1",1E-4);
	PrNoise2		   =ini->ReadFloat	("opt","prnoise2",1E-3);
	PrNoise3		   =ini->ReadFloat	("opt","prnoise3",1E-4);
	RovPosType		   =ini->ReadInteger("opt","rovpostype",0);
	RefPosType		   =ini->ReadInteger("opt","refpostype",2);
	RovPos[0]		   =ini->ReadFloat	("opt","rovpos1",0.0);
	RovPos[1]		   =ini->ReadFloat	("opt","rovpos2",0.0);
	RovPos[2]		   =ini->ReadFloat	("opt","rovpos3",0.0);
	RefPos[0]		   =ini->ReadFloat	("opt","refpos1",0.0);
	RefPos[1]		   =ini->ReadFloat	("opt","refpos2",0.0);
	RefPos[2]		   =ini->ReadFloat	("opt","refpos3",0.0);
	RovAntPcv		   =ini->ReadInteger("opt","rovantpcv",0);
	RefAntPcv		   =ini->ReadInteger("opt","refantpcv",0);
	RovAnt			   =ini->ReadString ("opt","rovant","");
	RefAnt			   =ini->ReadString ("opt","refant","");
	RovAntE			   =ini->ReadFloat	("opt","rovante",0.0);
	RovAntN			   =ini->ReadFloat	("opt","rovantn",0.0);
	RovAntU			   =ini->ReadFloat	("opt","rovantu",0.0);
	RefAntE			   =ini->ReadFloat	("opt","refante",0.0);
	RefAntN			   =ini->ReadFloat	("opt","refantn",0.0);
	RefAntU			   =ini->ReadFloat	("opt","refantu",0.0);
	AntPcvFile		   =ini->ReadString ("opt","antpcvfile","");
	IntpRefObs		   =ini->ReadInteger("opt","intprefobs",0);
	NetRSCorr		   =ini->ReadInteger("opt","netrscorr",0);
	SatClkCorr		   =ini->ReadInteger("opt","satclkcorr",0);
	NetRSCorrFile1	   =ini->ReadString ("opt","netrscorrfile1","");
	NetRSCorrFile2	   =ini->ReadString ("opt","netrscorrfile2","");
	SatClkCorrFile	   =ini->ReadString ("opt","satclkcorrfile","");
	SbasCorr		   =ini->ReadInteger("opt","sbascorr",0);
	SbasCorr1		   =ini->ReadInteger("opt","sbascorr1",0);
	SbasCorr2		   =ini->ReadInteger("opt","sbascorr2",0);
	SbasCorr3		   =ini->ReadInteger("opt","sbascorr3",0);
	SbasCorr4		   =ini->ReadInteger("opt","sbascorr4",0);
	SbasCorrFile	   =ini->ReadString ("opt","sbascorrfile","");
	PrecEphFile		   =ini->ReadString ("opt","precephfile","");
	StaPosFile		   =ini->ReadString ("opt","staposfile","");
	GoogleEarthFile    =ini->ReadString ("opt","googleearthfile",GOOGLE_EARTH);
	
	ConvDialog->TimeSpan->Checked	 =ini->ReadInteger("conv","timespan",0);
	ConvDialog->TimeIntF->Checked	 =ini->ReadInteger("conv","timeintf",0);
	ConvDialog->TimeY1->Text		 =ini->ReadString ("conv","timey1","2000/01/01");
	ConvDialog->TimeH1->Text		 =ini->ReadString ("conv","timeh1","00:00:00");
	ConvDialog->TimeY2->Text		 =ini->ReadString ("conv","timey2","2000/01/01");
	ConvDialog->TimeH2->Text		 =ini->ReadString ("conv","timeh2","00:00:00");
	ConvDialog->TimeInt->Text		 =ini->ReadString ("conv","timeint","0");
	ConvDialog->TrackColor->ItemIndex=ini->ReadInteger("conv","trackcolor",5);
	ConvDialog->PointColor->ItemIndex=ini->ReadInteger("conv","pointcolor",5);
	ConvDialog->OutputAlt->ItemIndex =ini->ReadInteger("conv","outputalt",0);
	ConvDialog->OutputTime->ItemIndex=ini->ReadInteger("conv","outputtime",0);
	ConvDialog->AddOffset->Checked	 =ini->ReadInteger("conv","addoffset",0);
	ConvDialog->Offset1->Text		 =ini->ReadString ("conv","offset1","0");
	ConvDialog->Offset2->Text		 =ini->ReadString ("conv","offset2","0");
	ConvDialog->Offset3->Text		 =ini->ReadString ("conv","offset3","0");
	ConvDialog->Compress->Checked	 =ini->ReadInteger("conv","compress",0);
	
	TTextViewer::Color1=(TColor)ini->ReadInteger("viewer","color1",(int)clBlack);
	TTextViewer::Color2=(TColor)ini->ReadInteger("viewer","color2",(int)clWhite);
	TTextViewer::FontD=new TFont;
	TTextViewer::FontD->Name=ini->ReadString("viewer","fontname","Courier New");
	TTextViewer::FontD->Size=ini->ReadInteger("viewer","fontsize",9);
	delete ini;
	UpdateEnable();
	Caption=PRGNAME;
	OptDialog->Version->Caption=version;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	TIniFile *ini=new TIniFile("rtkpost.ini");
	ini->WriteInteger("set","timestart",TimeStart->Checked?1:0);
	ini->WriteInteger("set","timeend",TimeEnd->Checked?1:0);
	ini->WriteString ("set","timesys1",TimeSys1->Caption);
	ini->WriteString ("set","timey1",TimeY1->Text);
	ini->WriteString ("set","timeh1",TimeH1->Text);
	ini->WriteString ("set","timesys2",TimeSys2->Caption);
	ini->WriteString ("set","timey2",TimeY2->Text);
	ini->WriteString ("set","timeh2",TimeH2->Text);
	ini->WriteInteger("set","timeintf",TimeIntF->Checked?1:0);
	ini->WriteString ("set","timeint",TimeInt->Text);
	ini->WriteInteger("set","timeunitf",TimeUnitF->Checked?1:0);
	ini->WriteString ("set","timeunit",TimeUnit->Text);
	ini->WriteString ("set","inputfile1",InputFile1->Text);
	ini->WriteString ("set","inputfile2",InputFile2->Text);
	ini->WriteString ("set","inputfile3",InputFile3->Text);
	ini->WriteString ("set","outputfile",OutputFile->Text);
	ini->WriteInteger("set","inputformat1",InputFormat1->ItemIndex);
	ini->WriteInteger("set","inputformat3",InputFormat3->ItemIndex);
	
	WriteList(ini,"hist","inputfile1",InputFile1->Items);
	WriteList(ini,"hist","inputfile2",InputFile2->Items);
	WriteList(ini,"hist","inputfile3",InputFile3->Items);
	WriteList(ini,"hist","outputfile",OutputFile->Items);
	
	ini->WriteInteger("opt","posmode",PosMode);
	ini->WriteInteger("opt","freq",Freq);
	ini->WriteInteger("opt","solution",Solution);
	ini->WriteFloat  ("opt","elmask",ElMask);
	ini->WriteFloat  ("opt","snrmask",SnrMask);
	ini->WriteInteger("opt","solformat",SolFormat);
	ini->WriteInteger("opt","timeformat",TimeFormat);
	ini->WriteInteger("opt","latlonformat",LatLonFormat);
	ini->WriteString ("opt","fieldsep",FieldSep);
	ini->WriteInteger("opt","outputhead",OutputHead);
	ini->WriteInteger("opt","outputopt",OutputOpt);
	ini->WriteInteger("opt","outputdatum",OutputDatum);
	ini->WriteInteger("opt","outputheight",OutputHeight);
	ini->WriteInteger("opt","outputgeoid",OutputGeoid);
	ini->WriteInteger("opt","debugtrace",DebugTrace);
	ini->WriteString ("opt","outputfile",OutputFile->Text);
	ini->WriteInteger("opt","dynamicmodel",DynamicModel);
	ini->WriteInteger("opt","ionoest",IonoEst);
	ini->WriteInteger("opt","tropest",TropEst);
	ini->WriteFloat  ("opt","validthresar",ValidThresAR);
	ini->WriteInteger("opt","ambres",AmbRes);
	ini->WriteInteger("opt","outcntresetbias",OutCntResetBias);
	ini->WriteInteger("opt","lockcntfixamb",LockCntFixAmb);
	ini->WriteFloat  ("opt","elmaskar",ElMaskAR);
	ini->WriteFloat  ("opt","maxagediff",MaxAgeDiff);
	ini->WriteFloat  ("opt","rejectthres",RejectThres);
	ini->WriteFloat  ("opt","slipthres",SlipThres);
	ini->WriteInteger("opt","codesmooth",CodeSmooth);
	ini->WriteInteger("opt","numiter",NumIter);
	ini->WriteFloat  ("opt","measerr1",MeasErr1);
	ini->WriteFloat  ("opt","measerr2",MeasErr2);
	ini->WriteFloat  ("opt","measerr3",MeasErr3);
	ini->WriteFloat  ("opt","measerr4",MeasErr4);
	ini->WriteFloat  ("opt","satclkstab",SatClkStab);
	ini->WriteFloat  ("opt","prnoise1",PrNoise1);
	ini->WriteFloat  ("opt","prnoise2",PrNoise2);
	ini->WriteFloat  ("opt","prnoise3",PrNoise3);
	ini->WriteInteger("opt","rovpostype",RovPosType);
	ini->WriteInteger("opt","refpostype",RefPosType);
	ini->WriteFloat  ("opt","rovpos1",RovPos[0]);
	ini->WriteFloat  ("opt","rovpos2",RovPos[1]);
	ini->WriteFloat  ("opt","rovpos3",RovPos[2]);
	ini->WriteFloat  ("opt","refpos1",RefPos[0]);
	ini->WriteFloat  ("opt","refpos2",RefPos[1]);
	ini->WriteFloat  ("opt","refpos3",RefPos[2]);
	ini->WriteInteger("opt","rovantpcv",RovAntPcv);
	ini->WriteInteger("opt","refantpcv",RefAntPcv);
	ini->WriteString ("opt","rovant",RovAnt);
	ini->WriteString ("opt","refant",RefAnt);
	ini->WriteFloat  ("opt","rovante",RovAntE);
	ini->WriteFloat  ("opt","rovantn",RovAntN);
	ini->WriteFloat  ("opt","rovantu",RovAntU);
	ini->WriteFloat  ("opt","refante",RefAntE);
	ini->WriteFloat  ("opt","refantn",RefAntN);
	ini->WriteFloat  ("opt","refantu",RefAntU);
	ini->WriteString ("opt","antpcvfile",AntPcvFile);
	ini->WriteInteger("opt","intprefobs",IntpRefObs);
	ini->WriteInteger("opt","netrscorr",NetRSCorr);
	ini->WriteInteger("opt","satclkcorr",SatClkCorr);
	ini->WriteString ("opt","netrscorrfile1",NetRSCorrFile1);
	ini->WriteString ("opt","netrscorrfile2",NetRSCorrFile2);
	ini->WriteString ("opt","satclkcorrfile",SatClkCorrFile);
	ini->WriteInteger("opt","sbascorr",SbasCorr);
	ini->WriteInteger("opt","sbascorr1",SbasCorr1);
	ini->WriteInteger("opt","sbascorr2",SbasCorr2);
	ini->WriteInteger("opt","sbascorr3",SbasCorr3);
	ini->WriteInteger("opt","sbascorr4",SbasCorr4);
	ini->WriteString ("opt","sbascorrfile",SbasCorrFile);
	ini->WriteString ("opt","precephfile",PrecEphFile);
	ini->WriteString ("opt","staposfile",StaPosFile);
	ini->WriteString ("opt","googleearthfile",GoogleEarthFile);
	
	ini->WriteInteger("conv","timespan",ConvDialog->TimeSpan->Checked);
	ini->WriteString ("conv","timey1",ConvDialog->TimeY1->Text);
	ini->WriteString ("conv","timeh1",ConvDialog->TimeH1->Text);
	ini->WriteString ("conv","timey2",ConvDialog->TimeY2->Text);
	ini->WriteString ("conv","timeh2",ConvDialog->TimeH2->Text);
	ini->WriteInteger("conv","timeintf",ConvDialog->TimeIntF->Checked);
	ini->WriteString ("conv","timeint",ConvDialog->TimeInt->Text);
	ini->WriteInteger("conv","trackcolor",ConvDialog->TrackColor->ItemIndex);
	ini->WriteInteger("conv","pointcolor",ConvDialog->PointColor->ItemIndex);
	ini->WriteInteger("conv","outputalt",ConvDialog->OutputAlt->ItemIndex);
	ini->WriteInteger("conv","outputtime",ConvDialog->OutputTime->ItemIndex);
	ini->WriteInteger("conv","addoffset",ConvDialog->AddOffset->Checked);
	ini->WriteString ("conv","offset1",ConvDialog->Offset1->Text);
	ini->WriteString ("conv","offset2",ConvDialog->Offset2->Text);
	ini->WriteString ("conv","offset3",ConvDialog->Offset3->Text);
	ini->WriteInteger("conv","compress",ConvDialog->Compress->Checked);
	
	ini->WriteInteger("viewer","color1",(int)TTextViewer::Color1);
	ini->WriteInteger("viewer","color2",(int)TTextViewer::Color2);
	ini->WriteString ("viewer","fontname",TTextViewer::FontD->Name);
	ini->WriteInteger("viewer","fontsize",TTextViewer::FontD->Size);
	delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputPlot1Click(TObject *Sender)
{
	AnsiString files[]={InputFile1->Text,InputFile2->Text};
	char navfile[1024];
	if (files[1]=="") {
		if (ObsToNav(InputFile1->Text.c_str(),navfile)) files[1]=navfile;
	}
	if (TimeStart->Checked) {
		gtime_t time=GetTime1();
		files[0]=RepFile(files[0],time,"");
		files[1]=RepFile(files[1],time,"");
	}
	AnsiString cmd="rtkplot -r \""+files[0]+"\" \""+files[1]+"\"";
	if (!ExecCmd(cmd,1)) ShowMsg("error : rtkplot execution");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputPlot3Click(TObject *Sender)
{
	AnsiString files[]={InputFile3->Text,InputFile2->Text};
	char navfile[1024];
	if (files[1]=="") {
		if (ObsToNav(InputFile1->Text.c_str(),navfile)) files[1]=navfile;
	}
	if (TimeStart->Checked) {
		gtime_t time=GetTime1();
		files[0]=RepFile(files[0],time,"");
		files[1]=RepFile(files[1],time,"");
	}
	AnsiString cmd="rtkplot -r \""+files[0]+"\" \""+files[1]+"\"";
	if (!ExecCmd(cmd,1)) ShowMsg("error : rtkplot execution");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnPlotClick(TObject *Sender)
{
	AnsiString file=OutputFile->Text;
	if (TimeStart->Checked) {
		gtime_t time=GetTime1();
		file=RepFile(file,time,"");
	}
	AnsiString cmd="rtkplot \""+file+"\"";
	if (!ExecCmd(cmd,1)) ShowMsg("error : rtkplot execution");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnViewClick(TObject *Sender)
{
	ViewFile(OutputFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnToKMLClick(TObject *Sender)
{
	ConvDialog->Show();	
	ConvDialog->SetInput(OutputFile->Text);	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnOptionClick(TObject *Sender)
{
	if (OptDialog->ShowModal()!=mrOk) return;
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnStopClick(TObject *Sender)
{
	showmsg("abort");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnExecClick(TObject *Sender)
{
	if (BtnExec->Caption=="Abort") {
		BtnExec->Enabled=false;
		return;
	}
	if (InputFile1->Text=="") {
		showmsg("error : no rover observation file");
		return;
	}
	if (InputFile3->Text==""&&PosMode>0) {
		showmsg("error : no reference observation file");
		return;
	}
	if (OutputFile->Text=="") {
		showmsg("error : no output file");
		return;
	}
	char *p;
	if (p=strrchr(OutputFile->Text.c_str(),'.')) {
		if (!strcmp(p,".obs")||!strcmp(p,".OBS")||!strcmp(p,".nav")||
			!strcmp(p,".NAV")||!strcmp(p,".gz")||!strcmp(p,".Z")||
			!strcmp(p+3,"o")||!strcmp(p+3,"O")||!strcmp(p+3,"d")||
			!strcmp(p+3,"D")||!strcmp(p+3,"n")||!strcmp(p+3,"N")) {
			showmsg("error : output file extenstion error (%s)",p);
			return;
		}
	}
	showmsg("");
	BtnExec->Caption="Abort";
	BtnExit->Enabled=false;
	BtnView->Enabled=false;
	BtnToKML->Enabled=false;
	BtnPlot->Enabled=false;
	BtnOption->Enabled=false;
	Panel1->Enabled=false;
	if (ExecProc()>=0) {
		AddHist(InputFile1);
		AddHist(InputFile2);
		AddHist(InputFile3);
		AddHist(OutputFile);
	}
	if (strstr(Message->Caption.c_str(),"processing")) showmsg("done");
	BtnExec->Caption="E&xecute";
	BtnExec->Enabled=true;
	BtnExit->Enabled=true;
	BtnView->Enabled=true;
	BtnToKML->Enabled=true;
	BtnPlot->Enabled=true;
	BtnOption->Enabled=true;
	Panel1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeStartClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeIntFClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeUnitFClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PosModeChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SolutionChange(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RefPosClick(TObject *Sender)
{
	UpdateEnable();	
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputFile1Click(TObject *Sender)
{
	OpenDialog->Title="Observation Data File";
	OpenDialog->FileName="";
	OpenDialog->FilterIndex=1;
	if (!OpenDialog->Execute()) return;
	InputFile1->Text=OpenDialog->FileName;
	char file[1024],*p;
	strcpy(file,InputFile1->Text.c_str());
	if (!(p=strrchr(file,'.'))) p=file+strlen(file);
	strcpy(p,".pos");
	OutputFile->Text=file;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputFile2Click(TObject *Sender)
{
	OpenDialog->Title="Navigation Messages File";
	OpenDialog->FileName="";
	OpenDialog->FilterIndex=3;
	if (!OpenDialog->Execute()) return;
	InputFile2->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputFile3Click(TObject *Sender)
{
	OpenDialog->Title="Base Station Observation File";
	OpenDialog->FileName="";
	OpenDialog->FilterIndex=1;
	if (!OpenDialog->Execute()) return;
	InputFile3->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnOutputFileClick(TObject *Sender)
{
	SaveDialog->Title="Solution File";
	SaveDialog->FileName="";
	OpenDialog->FilterIndex=4;
	if (!SaveDialog->Execute()) return;
	OutputFile->Text=SaveDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputView1Click(TObject *Sender)
{
	ViewFile(InputFile1->Text);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputView2Click(TObject *Sender)
{
	AnsiString file=InputFile2->Text;;
	char f[1024];
	if (file=="") {
		if (!ObsToNav(InputFile1->Text.c_str(),f)) return;
		file=f;
	}
	ViewFile(file);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BtnInputView3Click(TObject *Sender)
{
	ViewFile(InputFile3->Text);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SolFormatChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::ExecProc(void)
{
	gtime_t ts={0},te={0},t0={0};
	if (TimeStart->Checked) ts=GetTime1();
	if (TimeEnd  ->Checked) te=GetTime2();
	if (TimeUnitF->Checked) {
		double tu=TimeUnit->Text.ToDouble()*3600.0;
		int week,is,stat=-1;
		is=(int)floor(time2gpst(ts,&week)/tu);
		if (TimeUnitF->Checked) {settspan(t0,t0); settspan(ts,te);}
		for (int i=is;;i++) {
			gtime_t tts=gpst2time(week,i*tu),tte=timeadd(tts,tu-0.01);
			if (timediff(tts,te)>0.0) break;
			if (timediff(tts,ts)<0.0) tts=ts;
			if (timediff(tte,te)>0.0) tte=te;
			stat=ExecProcUnit(tts,tte);
			if (!MainForm->BtnExec->Enabled) stat=1;
			if (stat==1) {
				showmsg("aborted"); break;
			}
		}
		return stat;
	}
	else return ExecProcUnit(ts,te);
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::ExecProcUnit(gtime_t ts, gtime_t te)
{
	AnsiString input1,input2,input3,input4,output,satclk,rcv;
	int nfile=0,informat[4]={0};
	char *p,s1[4][1024]={{0}};
	char *infile[]={s1[0],s1[1],s1[2],s1[3]},outfile[256];
	double tint=0.0;
	prcopt_t prcopt=prcopt_default;
	solopt_t solopt=solopt_default;
	
	input1=RepFile(InputFile1->Text,ts,rcv);
	input2=RepFile(InputFile2->Text,ts,rcv);
	input3=RepFile(InputFile3->Text,ts,rcv);
	input4=RepFile(SbasCorrFile,ts,rcv);
	output=RepFile(OutputFile->Text,ts,rcv);
	satclk=RepFile(SatClkCorrFile,ts,rcv);
	
	strcpy(infile[nfile],input1.c_str());
	informat[nfile++]=InputFormat1->ItemIndex;
	if (PosMode) {
		strcpy(infile[nfile],input3.c_str());
		informat[nfile++]=InputFormat3->ItemIndex;
	}
	if (input2!="") {
		strcpy(infile[nfile],input2.c_str());
		informat[nfile++]=RCVLOG_RINEX;
	}
	else if (InputFormat1->ItemIndex==0) {
		if (!ObsToNav(input1.c_str(),infile[nfile])) {
			showmsg("error : no navigation message");
			return 0;
		}
		informat[nfile++]=RCVLOG_RINEX;
	}
	if (SbasCorr&&input4!="") {
		strcpy(infile[nfile],input4.c_str());
		informat[nfile++]=RCVLOG_SBAS;
	}
	if (TimeIntF->Checked) tint=TimeInt->Text.ToDouble();
	if (!GetOption(prcopt,solopt)) return 0;
	int dirs=prcopt.mode==0?0:Solution;
	if (!TimeUnitF->Checked) {
		FILE *fp;
		if ((fp=fopen(output.c_str(),"r"))) {
			fclose(fp);
			ConfDialog->Label2->Caption=output;
			if (ConfDialog->ShowModal()!=mrOk) return 0;
		}
	}
	strcpy(outfile,output.c_str());
	if (ts.time==0) {
		showmsg("reading files ...");
		settime(ts);
	}
	else {
		char ss1[64],ss2[64];
		time2str(ts,ss1,0); time2str(te,ss2,0);
		showmsg("reading files : %s-%s",ss1,ss2+5);
		settime(ts);
	}
	if (DebugTrace>0) {
		char file[1024];
		sprintf(file,"%s.trace",outfile);
		traceopen(file);
		tracelevel(DebugTrace);
	}
	int stat=postpos(ts,te,tint,dirs,&prcopt,&solopt,infile,nfile,outfile,
					 informat);
	if (DebugTrace) traceclose();
	return stat;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ShowMsg(char *msg)
{
	Message->Caption=msg;
	Message->Font->Color=strstr(msg,"error")?clRed:clBlue;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateEnable(void)
{
	InputFile3	 ->Enabled=PosMode>=1;
	BtnInputFile3->Enabled=PosMode>=1;
	BtnInputPlot3->Enabled=PosMode>=1;
	BtnInputView3->Enabled=PosMode>=1;
	LabelInputFile3->Enabled=PosMode>=1;
//	InputFormat3->Enabled=PosMode>=1;
//	LabelFormatInput3->Enabled=PosMode>=1;
	TimeSys1	 ->Enabled=TimeStart->Checked;
	TimeY1		 ->Enabled=TimeStart->Checked;
	TimeH1		 ->Enabled=TimeStart->Checked;
	TimeY1UD	 ->Enabled=TimeStart->Checked;
	TimeH1UD	 ->Enabled=TimeStart->Checked;
	TimeSys2	 ->Enabled=TimeEnd->Checked;
	TimeY2		 ->Enabled=TimeEnd->Checked;
	TimeH2		 ->Enabled=TimeEnd->Checked;
	TimeY2UD	 ->Enabled=TimeEnd->Checked;
	TimeH2UD	 ->Enabled=TimeEnd->Checked;
	TimeInt		 ->Enabled=TimeIntF->Checked;
	LabelTimeInt ->Enabled=TimeIntF->Checked;
	TimeUnit	 ->Enabled=TimeUnitF->Checked;
	LabelTimeUnit->Enabled=TimeUnitF->Checked;
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::GetOption(prcopt_t &prcopt, solopt_t &solopt)
{
	prcopt.mode=PosMode;
	prcopt.nf=Freq+1;
	prcopt.elmin=ElMask*D2R;
	prcopt.snrmin=SnrMask;
	prcopt.modear=PosMode>=2&&AmbRes==2;
	prcopt.maxout=OutCntResetBias;
	prcopt.minlock=LockCntFixAmb;
	prcopt.elmaskar=ElMaskAR*D2R;
	prcopt.estiono=IonoEst;
	prcopt.esttrop=TropEst;
	prcopt.niter=NumIter;
	prcopt.codesmooth=CodeSmooth;
	prcopt.err[0]=MeasErr1;
	prcopt.err[1]=MeasErr2;
	prcopt.err[2]=MeasErr3;
	prcopt.err[3]=MeasErr4;
	prcopt.sclkstab=SatClkStab;
	prcopt.prn[0]=PrNoise1;
	prcopt.prn[1]=PrNoise2;
	prcopt.prn[2]=PrNoise3;
	
	if (PosMode<=4||RovPosType==3) {
		for (int i=0;i<3;i++) prcopt.ru[i]=0.0;
	}
	else if (RovPosType<=2) {
		for (int i=0;i<3;i++) prcopt.ru[i]=RovPos[i];
	}
	else if (!GetPos(InputFile1->Text.c_str(),prcopt.ru)) {
		showmsg("error : no rover pos : %s",StaPosFile.c_str());
		return 0;
	}
	if (PosMode==0||PosMode==4||RefPosType==3) { /* get from file */
		for (int i=0;i<3;i++) prcopt.rb[i]=0.0;
	}
	else if (RefPosType<=2) {
		for (int i=0;i<3;i++) prcopt.rb[i]=RefPos[i];
	}
	else if (!GetPos(InputFile3->Text.c_str(),prcopt.rb)) {
		showmsg("error : no base position in %s",StaPosFile.c_str());
		return 0;
	}
	if (RovAntPcv) {
		if (prcopt.pcvu) free(prcopt.pcvu);
		if (!(prcopt.pcvu=(pcv_t *)malloc(sizeof(pcv_t)))) return 0;
		if (readpcv(AntPcvFile.c_str(),RovAnt.c_str(),prcopt.pcvu)) {
			showmsg("error : no antenna pcv in %s",RovAnt.c_str());
			return 0;
		}
		prcopt.pcvu->ecc[0]=RovAntE;
		prcopt.pcvu->ecc[1]=RovAntN;
		prcopt.pcvu->ecc[2]=RovAntU;
	}
	if (RefAntPcv) {
		if (prcopt.pcvr) free(prcopt.pcvr);
		if (!(prcopt.pcvr=(pcv_t *)malloc(sizeof(pcv_t)))) return 0;
		if (readpcv(AntPcvFile.c_str(),RefAnt.c_str(),prcopt.pcvr)) {
			showmsg("error : no antenna pcv : %s",RefAnt.c_str());
			return 0;
		}
		prcopt.pcvr->ecc[0]=RefAntE;
		prcopt.pcvr->ecc[1]=RefAntN;
		prcopt.pcvr->ecc[2]=RefAntU;
	}
	if (SbasCorr) {
		if (SbasCorr1) prcopt.sbascorr|=SBSOPT_LCORR;
		if (SbasCorr2) prcopt.sbascorr|=SBSOPT_ICORR;
		if (SbasCorr3) prcopt.sbascorr|=SBSOPT_FCORR;
		if (SbasCorr4) prcopt.sbascorr|=SBSOPT_RANGE;
	}
	prcopt.thresar=AmbRes==0?0.0:ValidThresAR;
	prcopt.thresslip=SlipThres;
	prcopt.maxtdiff=MaxAgeDiff;
	prcopt.maxinno=RejectThres;
	prcopt.intpref=IntpRefObs;
	
	solopt.posf=SolFormat;
	solopt.times=TimeFormat==0?0:TimeFormat-1;
	solopt.timef=TimeFormat==0?0:1;
	solopt.timeu=3;
	solopt.degf=LatLonFormat;
	solopt.outhead=OutputHead;
	solopt.outopt=OutputOpt;
	solopt.datum=OutputDatum;
	solopt.height=OutputHeight;
	solopt.geoid=OutputGeoid;
	strcpy(solopt.sep,FieldSep!=""?FieldSep.c_str():" ");
	return 1;
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::ObsToNav(const char *obsfile, char *navfile)
{
	char *p;
	strcpy(navfile,obsfile);
	if (!(p=strrchr(navfile,'.'))) return 0;
	if		(strlen(p)==4&&*(p+3)=='o') *(p+3)='n';
	else if (strlen(p)==4&&*(p+3)=='O') *(p+3)='N';
	else if (!strcmp(p,".obs")) strcpy(p,".nav");
	else if (!strcmp(p,".OBS")) strcpy(p,".NAV");
	else if (!strcmp(p,".gz")||!strcmp(p,".Z")) {
		if		(*(p-1)=='o') *(p-1)='n';
		else if (*(p-1)=='O') *(p-1)='N';
		else return 0;
	}
	else return 0;
	return 1;
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::GetPos(char *file, double *rr)
{
	FILE *fp;
	char buff[256],code[256],*sta,*p,*q;
	double pos[3];
	int stat=0;
	if (!(fp=fopen(StaPosFile.c_str(),"r"))) return 0;
	if ((p=strrchr(file,'/'))||(p=strrchr(file,'\\'))) sta=p+1; else sta=file;
	while (fgets(buff,sizeof(buff),fp)) {
		if ((p=strchr(buff,'%'))) *p='\0';
		if (sscanf(buff,"%lf %lf %lf %s",pos,pos+1,pos+2,code)<4) continue;
		for (p=code,q=sta;*p&&*q;p++,q++) if (toupper(*p)!=toupper(*q)) break;
		if (*p) continue;
		pos[0]*=D2R; pos[1]*=D2R;
		pos2ecef(pos,rr);
		stat=1;
		break;
	}
	fclose(fp);
	return stat;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AddHist(TComboBox *combo)
{
	AnsiString hist=combo->Text;
	if (hist=="") return;
	TStrings *list=combo->Items;
	int i=list->IndexOf(hist);
	if (i>=0) list->Delete(i);
	list->Insert(0,hist);
	for (int i=list->Count-1;i>=MAXHIST;i--) list->Delete(i);
	combo->ItemIndex=0;
}
//---------------------------------------------------------------------------
TStringList * __fastcall TMainForm::ReadList(TIniFile *ini, AnsiString cat,
	AnsiString key)
{
	TStringList *list=new TStringList;
	for (int i=0;i<100;i++) {
		AnsiString s,item;
		item=ini->ReadString(cat,s.sprintf("%s_%03d",key.c_str(),i),"");
		if (item!="") list->Add(item); else break;
	}
	return list;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WriteList(TIniFile *ini, AnsiString cat,
	AnsiString key, TStrings *list)
{
	for (int i=0;i<list->Count;i++) {
		AnsiString s;
		ini->WriteString(cat,s.sprintf("%s_%03d",key.c_str(),i),list->Strings[i]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewFile(AnsiString file)
{
	if (file=="") return;
	if (TimeStart->Checked) {
		gtime_t time=GetTime1();
		file=RepFile(file,time,"");
	}
	char tmpfile[1024];
	int cstat=uncompress(file.c_str(),tmpfile);
	AnsiString f(!cstat?file.c_str():tmpfile);
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(f);
	if (cstat==1) remove(tmpfile);
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::ExecCmd(AnsiString cmd, int show)
{
	PROCESS_INFORMATION info;
	STARTUPINFO si={0};
	si.cb=sizeof(si);
	char *p=cmd.c_str();
	if (!CreateProcess(NULL,p,NULL,NULL,false,show?0:CREATE_NO_WINDOW,NULL,
					   NULL,&si,&info)) return 0;
	CloseHandle(info.hProcess);
	CloseHandle(info.hThread);
	return 1;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::RepFile(AnsiString file, gtime_t time,
	AnsiString rcv)
{
	AnsiString s;
	int week,dow,doy;
	double tow,ep[6],ep0[6]={2000,1,1,0,0,0};
	time2epoch(time,ep);
	ep0[0]=ep[0];
	dow=(int)floor(time2gpst(time,&week)/86400.0)+1;
	doy=(int)floor(timediff(time,epoch2time(ep0))/86400.0)+1;
	file=RepStr(file,"%S",rcv.UpperCase().c_str());
	file=RepStr(file,"%s",rcv.LowerCase().c_str());
	file=RepStr(file,"%Y",s.sprintf("%04.0f",ep[0]));
	file=RepStr(file,"%y",s.sprintf("%02.0f",fmod(ep[0],100.0)));
	file=RepStr(file,"%m",s.sprintf("%02.0f",ep[1]));
	file=RepStr(file,"%d",s.sprintf("%02.0f",ep[2]));
	file=RepStr(file,"%n",s.sprintf("%03d",doy));
	file=RepStr(file,"%D",s.sprintf("%d",dow));
	file=RepStr(file,"%W",s.sprintf("%04d",week));
	file=RepStr(file,"%h",s.sprintf("%02d",(int)ep[3]));
	file=RepStr(file,"%H",s.sprintf("%c",'a'+(int)ep[3]));
	file=RepStr(file,"%f",s.sprintf("%d",(int)ep[3]/3+1));
	file=RepStr(file,"%t",s.sprintf("%02d",(int)ep[4]));
	return file;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::RepStr(AnsiString str, AnsiString pat,
	AnsiString rep)
{
	char *p,*q,*r,buff[1024];
	for (p=str.c_str(),r=buff;*p;) {
		if (!(q=strstr(p,pat.c_str()))) break;
		strncpy(r,p,q-p); r+=q-p;
		strcpy(r,rep.c_str()); r+=strlen(r);
		p=q+strlen(pat.c_str());
	}
	strcpy(r,p);
	AnsiString s(buff);
	return s;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeY1UDChangingEx(TObject *Sender,
	  bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	int week=1400;
	double ep[]={2000,1,1,0,0,0},yd[]={2000,1,0,0,0};
	int p=TimeY1->SelStart,ud=Direction==updUp?1:-1;
	if (TimeSys1->Caption=="(YMDhms)") {
		sscanf(TimeY1->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
		if (4<p&&p<8) {
			ep[1]+=ud;
			if (ep[1]<=0) {ep[0]--; ep[1]+=12;}
			else if (ep[1]>12) {ep[0]++; ep[1]-=12;}
		}
		else if (p>7||p==0) ep[2]+=ud; else ep[0]+=ud;
		time2epoch(epoch2time(ep),ep);
		TimeY1->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
		TimeY1->SelStart=p>7||p==0?10:(p>4?7:4);
	}
	else if (TimeSys1->Caption=="(YDhms)") {
		sscanf(TimeY1->Text.c_str(),"%lf/%lf",yd,yd+1);
		if (4<p) yd[1]+=ud; else yd[0]+=ud;
		TimeToYD(YDToTime(yd),yd);
		TimeY1->Text=s.sprintf("%04.0f/%03.0f",yd[0],yd[1]);
		TimeY1->SelStart=p>4?8:4;
	}
	else {
		sscanf(TimeY1->Text.c_str(),"%d",&week);
		TimeY1->Text=s.sprintf("%04d",week+ud);
		TimeY1->SelStart=4;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeH1UDChangingEx(TObject *Sender,
	  bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	double tow=0.0;
	int hms[3]={0},sec,p=TimeH1->SelStart,ud=Direction==updUp?1:-1;
	if (TimeSys1->Caption=="(YMDhms)"||TimeSys1->Caption=="(YDhms)") {
		sscanf(TimeH1->Text.c_str(),"%d:%d:%d",hms,hms+1,hms+2);
		if (p>5||p==0) hms[2]+=ud; else if (p>2) hms[1]+=ud; else hms[0]+=ud;
		sec=hms[0]*3600+hms[1]*60+hms[2];
		if (sec<0) sec+=86400; else if (sec>=86400) sec-=86400;
		TimeH1->Text=s.sprintf("%02d:%02d:%02d",sec/3600,(sec%3600)/60,sec%60);
		TimeH1->SelStart=p>5||p==0?8:(p>2?5:2);
	}
	else {
		sscanf(TimeH1->Text.c_str(),"%lf",&tow);
		tow+=ud;
		tow=tow-floor(tow/604800.0)*604800.0;
		TimeH1->Text=s.sprintf("%06.0f",tow);
		TimeH1->SelStart=6;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeY2UDChangingEx(TObject *Sender,
	  bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	int week=1400;
	double ep[]={2000,1,1,0,0,0},yd[]={2000,1,0,0,0};
	int p=TimeY2->SelStart,ud=Direction==updUp?1:-1;
	if (TimeSys2->Caption=="(YMDhms)") {
		sscanf(TimeY2->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
		if (4<p&&p<8) {
			ep[1]+=ud;
			if (ep[1]<=0) {ep[0]--; ep[1]+=12;}
			else if (ep[1]>12) {ep[0]++; ep[1]-=12;}
		}
		else if (p>7||p==0) ep[2]+=ud; else ep[0]+=ud;
		time2epoch(epoch2time(ep),ep);
		TimeY2->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
		TimeY2->SelStart=p>7||p==0?10:(p>4?7:4);
	}
	else if (TimeSys2->Caption=="(YDhms)") {
		sscanf(TimeY2->Text.c_str(),"%lf/%lf",yd,yd+1);
		if (4<p) yd[1]+=ud; else yd[0]+=ud;
		TimeToYD(YDToTime(yd),yd);
		TimeY2->Text=s.sprintf("%04.0f/%03.0f",yd[0],yd[1]);
		TimeY2->SelStart=p>4?8:4;
	}
	else {
		sscanf(TimeY2->Text.c_str(),"%d",&week);
		TimeY2->Text=s.sprintf("%04d",week+ud);
		TimeY2->SelStart=4;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeH2UDChangingEx(TObject *Sender,
	  bool &AllowChange, short NewValue, TUpDownDirection Direction)
{
	AnsiString s;
	double tow=0.0;
	int hms[3]={0},sec,p=TimeH2->SelStart,ud=Direction==updUp?1:-1;
	if (TimeSys2->Caption=="(YMDhms)"||TimeSys2->Caption=="(YDhms)") {
		sscanf(TimeH2->Text.c_str(),"%d:%d:%d",hms,hms+1,hms+2);
		if (p>5||p==0) hms[2]+=ud; else if (p>2) hms[1]+=ud; else hms[0]+=ud;
		sec=hms[0]*3600+hms[1]*60+hms[2];
		if (sec<0) sec+=86400; else if (sec>=86400) sec-=86400;
		TimeH2->Text=s.sprintf("%02d:%02d:%02d",sec/3600,(sec%3600)/60,sec%60);
		TimeH2->SelStart=p>5||p==0?8:(p>2?5:2);
	}
	else {
		sscanf(TimeH2->Text.c_str(),"%lf",&tow);
		tow+=ud;
		tow=tow-floor(tow/604800.0)*604800.0;
		TimeH2->Text=s.sprintf("%06.0f",tow);
		TimeH2->SelStart=6;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeSys1Click(TObject *Sender)
{
	int i;
	AnsiString s[]={"(YMDhms)","(YDhms)","(GPST)"};
	gtime_t time=GetTime1();
	for (i=0;i<3;i++) if (TimeSys1->Caption==s[i]) break;
	TimeSys1->Caption=s[i<2?i+1:0];
	SetTime1(time);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimeSys2Click(TObject *Sender)
{
	int i;
	AnsiString s[]={"(YMDhms)","(YDhms)","(GPST)"};
	gtime_t time=GetTime2();
	for (i=0;i<3;i++) if (TimeSys2->Caption==s[i]) break;
	TimeSys2->Caption=s[i<2?i+1:0];
	SetTime2(time);
}
//---------------------------------------------------------------------------
gtime_t _fastcall TMainForm::GetTime1(void)
{
	int week=1400;
	double tow=0.0,ep[]={2000,1,1,0,0,0},yd[]={2000,1,0,0,0};
	if (TimeSys1->Caption=="(YMDhms)") {
		sscanf(TimeY1->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
		sscanf(TimeH1->Text.c_str(),"%lf:%lf:%lf",ep+3,ep+4,ep+5);
		return epoch2time(ep);
	}
	else if (TimeSys1->Caption=="(YDhms)") {
		sscanf(TimeY1->Text.c_str(),"%lf/%lf",yd,yd+1);
		sscanf(TimeH1->Text.c_str(),"%lf:%lf:%lf",yd+2,yd+3,yd+4);
		return YDToTime(yd);
	}
	else {
		sscanf(TimeY1->Text.c_str(),"%d",&week);
		sscanf(TimeH1->Text.c_str(),"%lf",&tow);
		return gpst2time(week,tow);
	}
}
//---------------------------------------------------------------------------
gtime_t _fastcall TMainForm::GetTime2(void)
{
	int week=1400;
	double tow=0.0,ep[]={2000,1,1,0,0,0},yd[]={2000,1,0,0,0};
	if (TimeSys2->Caption=="(YMDhms)") {
		sscanf(TimeY2->Text.c_str(),"%lf/%lf/%lf",ep,ep+1,ep+2);
		sscanf(TimeH2->Text.c_str(),"%lf:%lf:%lf",ep+3,ep+4,ep+5);
		return epoch2time(ep);
	}
	else if (TimeSys2->Caption=="(YDhms)") {
		sscanf(TimeY2->Text.c_str(),"%lf/%lf",yd,yd+1);
		sscanf(TimeH2->Text.c_str(),"%lf:%lf:%lf",yd+2,yd+3,yd+4);
		return YDToTime(yd);
	}
	else {
		sscanf(TimeY2->Text.c_str(),"%d",&week);
		sscanf(TimeH2->Text.c_str(),"%lf",&tow);
		return gpst2time(week,tow);
	}
}
//---------------------------------------------------------------------------
void _fastcall TMainForm::SetTime1(gtime_t time)
{
	AnsiString s;
	int week;
	double tow,ep[6],yd[5];
	if (TimeSys1->Caption=="(YMDhms)") {
		time2epoch(time,ep);
		TimeY1->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
		TimeH1->Text=s.sprintf("%02.0f:%02.0f:%02.0f",ep[3],ep[4],ep[5]);
		TimeY1->SelStart=10; TimeH1->SelStart=10;
	}
	else if (TimeSys1->Caption=="(YDhms)") {
		TimeToYD(time,yd);
		TimeY1->Text=s.sprintf("%04.0f/%03.0f",yd[0],yd[1]);
		TimeH1->Text=s.sprintf("%02.0f:%02.0f:%02.0f",yd[2],yd[3],yd[4]);
		TimeY1->SelStart=8; TimeH1->SelStart=10;
	}
	else {
		tow=time2gpst(time,&week);
		TimeY1->Text=s.sprintf("%04d",week);
		TimeH1->Text=s.sprintf("%06.0f",tow);
		TimeY1->SelStart=4; TimeH1->SelStart=6;
	}
}
//---------------------------------------------------------------------------
void _fastcall TMainForm::SetTime2(gtime_t time)
{
	AnsiString s;
	int week;
	double tow,ep[6],yd[5];
	if (TimeSys2->Caption=="(YMDhms)") {
		time2epoch(time,ep);
		TimeY2->Text=s.sprintf("%04.0f/%02.0f/%02.0f",ep[0],ep[1],ep[2]);
		TimeH2->Text=s.sprintf("%02.0f:%02.0f:%02.0f",ep[3],ep[4],ep[5]);
		TimeY2->SelStart=10; TimeH2->SelStart=10;
	}
	else if (TimeSys2->Caption=="(YDhms)") {
		TimeToYD(time,yd);
		TimeY2->Text=s.sprintf("%04.0f/%03.0f",yd[0],yd[1]);
		TimeH2->Text=s.sprintf("%02.0f:%02.0f:%02.0f",yd[2],yd[3],yd[4]);
		TimeY2->SelStart=8; TimeH2->SelStart=10;
	}
	else {
		tow=time2gpst(time,&week);
		TimeY2->Text=s.sprintf("%04d",week);
		TimeH2->Text=s.sprintf("%06.0f",tow);
		TimeY2->SelStart=4; TimeH2->SelStart=6;
	}
}
//---------------------------------------------------------------------------
gtime_t _fastcall TMainForm::YDToTime(const double *yd)
{
	double ep[]={2000,1,1,0,0,0};
	ep[0]=yd[0]; ep[3]=yd[2]; ep[4]=yd[3]; ep[5]=yd[4];
	return timeadd(epoch2time(ep),(yd[1]-1.0)*86400.0);
}
//---------------------------------------------------------------------------
void _fastcall TMainForm::TimeToYD(gtime_t time, double *yd)
{
	double ep[6];
	time2epoch(time,ep);
	yd[0]=ep[0]; yd[2]=ep[3]; yd[3]=ep[4]; yd[4]=ep[5]; 
	ep[1]=ep[2]=1.0; yd[1]=floor(timediff(time,epoch2time(ep))/86400.0)+1.0;
}
//---------------------------------------------------------------------------
