/*------------------------------------------------------------------------------
* ublox.h : ublox receiver dependent functions
*
*          Copyright (C) 2007 by T.TAKASU, All rights reserved.
*
* version : $Revision: 1.2 $ $Date: 2008/07/14 00:05:05 $
* history : 2007/11/03 1.0 new
*-----------------------------------------------------------------------------*/
#ifndef UBLOX_H
#define UBLOX_H
#include "rtklib.h"

#ifdef __cplusplus
extern "C" {
#endif

#define OPTUBX5     0x1         /* ublox 5 option */

extern int decodeubx(const unsigned char *buff, int len, gtime_t ts, gtime_t te,
                     double tint, int opt, obs_t *obs, nav_t *nav,
                     sbsmsg_t *sbsmsg, int *sat);
extern void convubx(FILE *fp, FILE *ofp, FILE *nfp, FILE *sfp, gtime_t ts,
                    gtime_t te, double dec, const rnxopt_t *rnxopt, int opt);
extern void readubx(FILE *fp, gtime_t ts, gtime_t te, double tint, int opt,
                    obs_t *obs, nav_t *nav, sbs_t *sbs, int *nmax);

#ifdef __cplusplus
}
#endif
#endif /* UBLOX_H */
